#
# UPDATE WARNING: xtables-addons 2.0 support only kernels 3.7+
#
#
# Conditional build:
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace tools
%bcond_with	verbose		# verbose build (V=1)

# The goal here is to have main, userspace, package built once with
# simple release number, and only rebuild kernel packages with kernel
# version as part of release number, without the need to bump release
# with every kernel change.
%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	1
%define		pname	xtables-addons
Summary:	Additional extensions for xtables packet filtering system
Summary(pl.UTF-8):	Dodatkowe rozszerzenia do systemu filtrowania pakietów xtables
Name:		%{pname}%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	2.12
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	GPL v2
Group:		Networking/Admin
Source0:	http://downloads.sourceforge.net/xtables-addons/%{pname}-%{version}.tar.xz
# Source0-md5:	aed5ce0873709ac243f1177fc81ff452
URL:		http://xtables-addons.sourceforge.net/
BuildRequires:	autoconf >= 2.65
BuildRequires:	automake >= 1:1.11
BuildRequires:	iptables-devel >= 1.4.5
%{?with_kernel:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:3.7.0}}
BuildRequires:	libtool
BuildRequires:	pkgconfig >= 0.9.0
BuildRequires:	rpmbuild(macros) >= 1.678
BuildRequires:	tar >= 1.22
BuildRequires:	xz
Requires:	iptables >= 1.4.5
Obsoletes:	iptables-ipp2p
BuildRoot:	%{tmpdir}/%{pname}-%{version}-root-%(id -u -n)

%define		_duplicate_files_terminate_build	0

%description
xtables-addons is the proclaimed successor to patch-o-matic(-ng). It
contains extensions that were not accepted in the main
xtables/iptables package.

For the tools to work, you should install kernel modules, which could
be found in kernel*-net-xtables-addons.

%description -l pl.UTF-8
xtables-addons to następca patch-o-matic(-ng). Zawiera rozszerzenia,
które nie zostały zaakceptowane do głównego pakietu xtables/iptables.

Aby narzędzia działały należy zainstalować moduły jądra, które można
znaleźć w pakiecie kernel*-net-xtables-addons.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-net-xtables-addons\
Summary:	Kernel modules for xtables addons\
Summary(pl.UTF-8):	Moudły jądra dla rozszerzeń z pakietu xtables-addons\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
# VERSION only dependency is intentional, for allowing multiple kernel pkgs and\
# single userspace package installs.\
Requires:	%{pname} = %{version}\
Suggests:	xtables-geoip\
Conflicts:	xtables-geoip < 20090901-2\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-net-xtables-addons\
Kernel modules for xtables addons.\
\
%description -n kernel%{_alt_kernel}-net-xtables-addons -l pl.UTF-8\
Moduły jądra dla rozszerzeń z pakietu xtables-addons.\
\
%files -n kernel%{_alt_kernel}-net-xtables-addons\
%defattr(644,root,root,755)\
# restricted permissions - may contain password\
%attr(600,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/xt_sysrq.conf\
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/compat_xtables.ko*\
/lib/modules/%{_kernel_ver}/kernel/net/netfilter/xt_*.ko*\
\
%post -n kernel%{_alt_kernel}-net-xtables-addons\
%depmod %{_kernel_ver}\
\
%postun -n kernel%{_alt_kernel}-net-xtables-addons\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
srcdir=${PWD:-$(pwd)}\
%build_kernel_modules XA_ABSTOPSRCDIR=$srcdir -C extensions -m compat_xtables\
for drv in extensions/compat_xtables.ko extensions/{ACCOUNT/,pknock/,}xt_*.ko ; do\
%install_kernel_modules -D installed -m ${drv%.ko} -d kernel/net/netfilter\
done\
%{nil}

%{?with_kernel:%{expand:%create_kernel_packages}}

%prep
%setup -q -n %{pname}-%{version}

%build
%configure \
	--without-kbuild

%{?with_kernel:%{expand:%build_kernel_packages}}

%if %{with userspace}
%{__make} \
	V=1
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with kernel}
install -d $RPM_BUILD_ROOT/etc/modprobe.d

cp -a installed/* $RPM_BUILD_ROOT

cat <<'EOF' > $RPM_BUILD_ROOT/etc/modprobe.d/xt_sysrq.conf
# Set password at modprobe time. This file is secure if properly guarded,
# i.e only readable by root.
#options xt_SYSRQ password=cookies

# The hash algorithm can also be specified as a module option, for example,
# to use SHA-256 instead of the default SHA-1:
#options xt_SYSRQ hash=sha256
EOF
%endif

%if %{with userspace}
%{__make} -C extensions install \
	DESTDIR=$RPM_BUILD_ROOT
%{__make} install-man \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} $RPM_BUILD_ROOT%{_libdir}/libxt_ACCOUNT_cl.{la,so}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc README doc/{README.psd,changelog.txt}
%attr(755,root,root) %{_sbindir}/iptaccount
%attr(755,root,root) %{_libdir}/libxt_ACCOUNT_cl.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libxt_ACCOUNT_cl.so.0
%attr(755,root,root) %{_libdir}/xtables/libxt_*.so
%{_mandir}/man8/iptaccount.8*
%{_mandir}/man8/xtables-addons.8*
%endif
%changelog
* Fri Jan 27 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/xtables-addons.git;a=log;h=auto/th/xtables-addons-2.12-1

* Sat Jan 21 2017 Jan Rękorajski <baggins@pld-linux.org> b351b59
- up to 2.12

* Mon Jun 06 2016 Jan Rękorajski <baggins@pld-linux.org> 7529846
- up to 2.11

* Sat Apr 16 2016 Jan Rękorajski <baggins@pld-linux.org> 07ae6fd
- rel 2

* Thu Dec 03 2015 Jan Rękorajski <baggins@pld-linux.org> b8a11eb
- up to 2.10

* Sun Sep 27 2015 Jan Rękorajski <baggins@pld-linux.org> 4a6f4b9
- up to 2.8

* Sat Jul 04 2015 Jan Rękorajski <baggins@pld-linux.org> 586530d
- uopdated to 2.6
- fixed building with linux 4.1

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 3eae76a
- x32 rebuild
- release 3 (by relup.sh)

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> 2199654
- rel 2

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> fbbd40f
- updated kernel modules build system

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> d505eca
- drop non-dist kernel support

* Sat Apr 26 2014 Jan Rękorajski <baggins@pld-linux.org> 7bdade5
- up to 2.5

* Thu Feb 20 2014 Jan Rękorajski <baggins@pld-linux.org> 632932d
- rel 3

* Sat Feb 15 2014 Jakub Bogusz <qboosh@pld-linux.org> 47695ee
- Linux < 3.7 is no longer supported by this package

* Fri Feb 14 2014 Jan Rękorajski <baggins@pld-linux.org> 63cac0d
- xt_sysrq.conf may be packaged for multiple kernels
- rel 2

* Fri Feb 14 2014 Jan Rękorajski <baggins@pld-linux.org> e77b171
- up to 2.4

* Tue Oct 29 2013 Jan Rękorajski <baggins@pld-linux.org> 0b25bb4
- switch to macro driven module build for multiple kernel versions
- rel 8

* Mon Oct 07 2013 Jan Rękorajski <baggins@pld-linux.org> 919c84a
- rebuild for kernel-3.10.15-1
- release 7 (by relup.sh)

* Wed Oct 02 2013 Jan Rękorajski <baggins@pld-linux.org> d489f82
- rebuild for kernel-3.10.14-1
- release 6 (by relup.sh)

* Fri Sep 27 2013 Jan Rękorajski <baggins@pld-linux.org> a02ef74
- rebuild for kernel-3.10.13-1
- release 5 (by relup.sh)

* Sun Sep 15 2013 Jan Rękorajski <baggins@pld-linux.org> 4196a76
- rebuild for kernel-3.10.12-1
- release 4 (by relup.sh)

